<?php
/*
 Plugin Name: Flash Header Rotator
 Plugin URI: http://pranshuarya.com/jaal/Development/wordpress-plugin-flash-header-rotator.html
 Description: An extension of Matthew Hough's <a href="http://www.wpimagerotator.com">Header Image Rotator</a> v2.0 to allow embedding of Flash (*.swf) files in the header.  See <a href="http://pranshuarya.com/jaal/Development/wordpress-plugin-flash-header-rotator.html">website</a> for usage and examples.
 Author: Pranshu Arya
 Version: 1.0
 Author URI: http://pthesis.com

 This plugin is based on the Header Image Rotator plugin by Matthew Hough (http://www.mhough.com). Thanks!

 Copyright (C) 2009 Pranshu Arya

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

/* Check to see if options already exist in the database */
$swap_rate = get_option('fhr_swap_rate');
$header_id = get_option('fhr_header_id');
$fhr_css = get_option('fhr_css');
$fhr_link_setting = get_option('fhr_link_setting');
$fhr_link_type = get_option('fhr_link_type');
$fhr_flash1 = get_option('fhr_flash1');
$fhr_flash2 = get_option('fhr_flash2');
$fhr_flash3 = get_option('fhr_flash3');
$fhr_flash_css = get_option('fhr_flash_css');
$fhr_transparency = get_option('fhr_transparency');
$fhr_pubmode = get_option('fhr_pubmode');

/* Add options if they does not already exist */
if($swap_rate == '') {
	add_option('fhr_swap_rate', '1');
}
if($header_id == '') {
	add_option('fhr_header_id', 'Enter your CSS ID here');
}
if($fhr_css == '') {
	add_option('fhr_css', 'no-repeat; background-position: top left;');
}
if($fhr_flash_css == '') {
	add_option('fhr_flash_css', 'position:static;');
}
if($fhr_link_setting == '') {
	add_option('fhr_link_setting', 'yes');
}
if($fhr_link_type == '') {
	add_option('fhr_link_type', 'google');
}
if($fhr_flash1 == '') {
	add_option('fhr_flash1', '8');
}
if($fhr_flash2 == '') {
	add_option('fhr_flash2', '0');
}
if($fhr_flash3 == '') {
	add_option('fhr_flash3', '0');
}
if($fhr_transparency == '') {
	add_option('fhr_transparency', '1');
}
if($fhr_pubmode == '') {
	add_option('fhr_pubmode', '0');
}

/* Define Constants and variables*/
define('IMAGE_FOLDER', 'header-images/');
define('IMAGE_PATH', ABSPATH .'wp-content/'.IMAGE_FOLDER);
define('IMAGE_URI', get_option('siteurl').'/wp-content/'.IMAGE_FOLDER);
define('PLUGIN_URI', get_option('siteurl').'/wp-content/plugins/image-rotator/');

/* Functions */
function get_files($dir) {
	$dir_check = is_dir(IMAGE_PATH);
	if(!$dir_check){

	} else {
		$dh  = opendir($dir);
		while (false !== ($filename = readdir($dh))) {
			$files[] = $filename;
		}
		$entries = array();
		if (is_dir($dir)) {
			foreach($files as $entry) {
				if($entry != '.' && $entry != '..') {
					$entries[] = $entry;
				}
			}
		}
	}
	return $entries;
}

function rotator_admin_menu() {
	add_submenu_page('options-general.php', 'Flash Header Rotator', 'Flash Header Rotator', 8, __FILE__, 'rotator_options');
}

function image_swap($sr) {
	$ent_temp = get_files(IMAGE_PATH);
	$count = count($ent_temp);
	$date = date($sr);
	$key = $date % $count;
	return IMAGE_URI . $ent_temp[$key];
}

function image_swap_half_hour() {
	$ent_temp = get_files(IMAGE_PATH);
	$count = count($ent_temp);
	$total_minute = (date(G)* 60)+ (date(i));
	$curr_min = $total_minute / 30;
	$curr_min = floor($curr_min);
	$key = $curr_min % $count;
	return IMAGE_URI . $ent_temp[$key];
}

function switch_image(){
	switch (get_option("fhr_swap_rate")) {
		case "0": //weekly
			return image_swap("W");

		case "1": //daily
			return image_swap("z");

		case "2": //hourly
			return image_swap("G");

		case "3": //half-hour
			return image_swap_half_hour();

		case "4": //minute
			return image_swap("i");
	}
}

function header_img_check() {
	$head_css = get_option('fhr_header_id');
	if($head_css !== "Enter your CSS ID here"){
		echo PLUGIN_URI.'img/ok.gif';
	} else {
		echo PLUGIN_URI.'img/error.gif';
	}
}

function image_path_check() {
	$pics = count(get_files(IMAGE_PATH));
	if(is_dir(IMAGE_PATH)&& $pics != 0){
		echo PLUGIN_URI.'img/ok.gif';
	} else {
		echo PLUGIN_URI.'img/error.gif';
	}
}

function image_path_message() {
	$dir = is_dir(IMAGE_PATH);
	$pics = count(get_files(IMAGE_PATH));
	if(!$dir){
		echo "<font color=\"red\">The plugin could not find or open the above image directory. Please make sure you have created a folder called 'header-images' (without the quote marks) in your wp-content folder.</font>";
	} elseif($pics == 0) {
		echo "<font color=\"red\">There are no pictures in your image folder. Please add some images for the plugin to work.</font>";
	}
}

function fhr_add_css(){
	$img = switch_image();
	$filetype = pathinfo($img, PATHINFO_EXTENSION);
	$headerID = get_option('fhr_header_id');
	$fhr_blog_URL = get_option('siteurl');
	$fhr_css = get_option('fhr_css');
	$fhr_flash_css = get_option('fhr_flash_css');
	$fhr_link_setting = get_option('fhr_link_setting');
	$fhr_link_type = get_option('fhr_link_type');
	$fhr_dir = PLUGIN_URI;
	
	if($fhr_link_setting == 'yes'){
		if($fhr_link_type == 'local'){
			print "<script src=\"".$fhr_dir."js/jquery-1.2.6.js\"></script>";
			print
			<<<EOT
			<script>
			jQuery(document).ready(function(){
			jQuery("div#$headerID")
			.wrap("<a href='$fhr_blog_URL'></a>");
			});
			</script>
EOT;
		}//end of type clause for local
		
		if($fhr_link_type == 'google'){
			print "<script src=\"http://www.google.com/jsapi\"></script>";
			print
			<<<EOT
			<script>
			google.load("jquery", "1");
			google.setOnLoadCallback(function() {
			//jQuery(document).ready(function(){
			jQuery("div#$headerID")
			.wrap("<a href='$fhr_blog_URL'></a>");
			});
			</script>
EOT;
		}//end of type clause for Google
	}//end of link setting if clause
	
	if($filetype != 'swf'){
	print <<<EOT
	<script type="text/javascript" language="javascript">
	var img = new Image();
	img.src = '$img';
	</script>
	<style type="text/css">
	#$headerID {
	background: url('$img') $fhr_css   
	}
	</style>
EOT;
	}
	
	else if($filetype == 'swf'){
		$temp = explode('/',$img);  // split up absolute url
		$filename = array_pop($temp);  // get the filename from the array $temp
		$temp = explode('.',$filename);  // split up the filename to get name without extension
		$params = explode('_',$temp[0]);  // separate filename by '_' (first element will be the movie name)
		if(count($params) == 3){
		$width = $params[1];  // second element of $params array = width
		$height = $params[2]; // third element of $params array = height
		}
		else{
		$temp = getimagesize($img);
		$width = $temp[0];
		$height = $temp[1];
		}
		
		$fhr_flash1 = get_option('fhr_flash1');
		$fhr_flash2 = get_option('fhr_flash2');
		$fhr_flash3 = get_option('fhr_flash3');
		$fhr_transparency = get_option('fhr_transparency');
		$fhr_pubmode = get_option('fhr_pubmode');
		
		if($fhr_pubmode == '1'){
			if($fhr_transparency == '1'){
				$par = 'wmode: "transparent"';
			}
			else
				$par = '';
		print <<<EOD
		<script type="text/javascript" language="javascript">
		
		if(typeof(swfobject) == 'undefined'){
		var script = document.createElement('script');
		script.type = "text/javascript";
		script.src = "$fhr_dir/js/swfobject.js";
		jQuery('head').append(script);
		}
		jQuery(document).ready(function(){
			var embed = '<div id="flash-_-header"></div>';
			jQuery("#$headerID").prepend(jQuery(embed));
			if (swfobject.hasFlashPlayerVersion("$fhr_flash1.$fhr_flash2.$fhr_flash3")) {
				  var fn = function() {
					var att = { data:"$img", width:"$width", height:"$height" };
					var par = { $par };
					var id = "flash-_-header";
					var myObject = swfobject.createSWF(att, par, id);
				  }
				  swfobject.addDomLoadEvent(fn);
			}
		});
	</script>
		<style type="text/css">
		#$headerID {
		background: none;
		}
		#flash-_-header {
		$fhr_flash_css
		}
		</style>
EOD;
		}
		else if($fhr_pubmode =='0'){
			if($fhr_transparency == '1'){
				$par = '<param name="wmode" value="transparent"><!--[if !IE]>-->';
				$par2 = '<param name="wmode" value="transparent">';
			}
			else {
				$par = '<!--[if !IE]>-->';
				$par2 = '';
			}
		print <<<EOT
		<script type="text/javascript" language="javascript">
		
		if(typeof(swfobject) == 'undefined'){
		var script = document.createElement('script');
		script.type = "text/javascript";
		script.src = "$fhr_dir/js/swfobject.js";
		jQuery('head').append(script);
		}
		swfobject.registerObject("flash", "$fhr_flash1.$fhr_flash2.$fhr_flash3");
		jQuery(document).ready(function(){
			var embed = '<div id="flash-_-header"><object id="flash-_-movie" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="$width" height="$height">';
			embed += '$par';
			embed += '<param name="movie" value="$img" />';
			embed += '<object type="application/x-shockwave-flash" data="$img" width="$width" height="$height">$par2';
			embed += '<!--<![endif]--><!--[if !IE]>--></object><!--<![endif]--></object></div>';
			jQuery("#$headerID").prepend(jQuery(embed));
		});
	</script>
		<style type="text/css">
		#$headerID {
		background: none;
		}
		#flash-_-header {
		$fhr_flash_css
		}
		#flash-_-movie {
		visibility: visible;
		}
		</style>
EOT;
		}
	}
}

function fhr_add_js() {
	print <<<EOT
	<script type="text/javascript">
	<!--
    function open_win(url, name, args) {
        newWindow = window.open(url, name, args);
        newWindow.screenX = window.screenX;
        newWindow.screenY = window.screenY;
        newWindow.focus();
    }
	//-->
	</script>
EOT;
}

function rotator_options() {
	if(isset($_POST['fhr_swap_rate'])){
		update_option("fhr_swap_rate", ($_POST["fhr_swap_rate"]));
	}
	if (isset($_POST['fhr_header_id'])){
		update_option("fhr_header_id", ($_POST['fhr_header_id']));
	}
	if (isset($_POST['fhr_css'])){
		update_option("fhr_css", ($_POST['fhr_css']));
	}
	if (isset($_POST['fhr_flash_css'])){
		update_option("fhr_flash_css", ($_POST['fhr_flash_css']));
	}
	if (isset($_POST['fhr_link_setting'])){
		update_option("fhr_link_setting", ($_POST['fhr_link_setting']));
	}
	if (isset($_POST['fhr_link_type'])){
		update_option("fhr_link_type", ($_POST['fhr_link_type']));
	}
	if (isset($_GET['to_del'])) {
		@unlink(IMAGE_PATH. $_GET['to_del']);
	}
	if(isset($_POST['fhr_flash1'])){
		update_option('fhr_flash1', ($_POST['fhr_flash1']));
	}
	if(isset($_POST['fhr_flash2'])){
		update_option('fhr_flash2', ($_POST['fhr_flash2']));
	}
	if(isset($_POST['fhr_flash3'])){
		update_option('fhr_flash3', ($_POST['fhr_flash3']));
	}
	if(isset($_POST['fhr_transparency'])){
		update_option('fhr_transparency', ($_POST['fhr_transparency']));
	}
	if(isset($_POST['fhr_pubmode'])){
		update_option('fhr_pubmode', ($_POST['fhr_pubmode']));
	}
	
?>
<div class="wrap">
<form method="post">
<h2>Image Settings</h2>
<h3 style="color:green">(These options are verbatim from <a href="http://www.wpimagerotator.com">Header Image Rotator</a>.)</h3>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php echo PLUGIN_URI.'img/ok.gif'; ?>"</td>
		<td><b>Swap rate:</b></td>
		<td><select name="fhr_swap_rate">
			<option
			<?php if(get_option('fhr_swap_rate') == "4") { echo "selected"; } ?>
				value="4">Minute</option>
			<option
			<?php if(get_option('fhr_swap_rate') == "3") { echo "selected"; } ?>
				value="3">Half-Hour</option>
			<option
			<?php if(get_option('fhr_swap_rate') == "2") { echo "selected"; } ?>
				value="2">Hourly</option>
			<option
			<?php if(get_option('fhr_swap_rate') == "1") { echo "selected"; } ?>
				value="1">Daily</option>
			<option
			<?php if(get_option('fhr_swap_rate') == "0") { echo "selected"; } ?>
				value="0">Weekly</option>
		</select></td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"></td>
		<td>This setting determines the interval at which your header images
		rotate.</td>
	</tr>
</table>
<p></p>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php header_img_check(); ?>"></td>
		<td><b>CSS header ID tag</b>:</td>
		<td><input type="text" name="fhr_header_id" size="24" border="0"
			value="<?php echo get_option('fhr_header_id'); ?>"></td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"></td>
		<td>
		<?php
		$head_css = get_option('fhr_header_id');
		if($head_css == "Enter your CSS ID here"){
			echo "<font color=\"red\">Please enter your CSS ID in the text box above and update.</font><br>This setting should be the CSS ID you wish to use to display the images. Examples would be 'header' (without the quote marks). This will be different depending on which theme you are using. Look through your theme's CSS file to find the correct CSS ID.";
		} else {
			echo "This setting should be the CSS ID you wish to use to display the images. Examples would be 'header' (without the quote marks). This will be different depending on which theme you are using. Look through your theme's CSS file to find the correct CSS ID.";
		}
		?>
		</td>
	</tr>
</table>
<p></p>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php echo PLUGIN_URI.'img/ok.gif'; ?>"></td>
		<td><b>Image CSS styling</b>:</td>
		<td><input type="text" name="fhr_css" size="80" border="0" value="<?php echo get_option('fhr_css'); ?>"></td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"></td>
		<td>This is the default CSS style applied to your rotating header images. If your header images are not displaying correctly, update the CSS styling in this field. If everything looks good, then nothing needs to be changed!</td>
	</tr>
</table>
<p></p>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php image_path_check(); ?>" alt=""></td>
		<td><b>Image path:</b></td>
		<td>/wp-content/header-images/</td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"></td>
		<td><?php image_path_message(); ?></td>
	</tr>
</table>
<p></p>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php echo PLUGIN_URI.'img/ok.gif'; ?>" alt=""></td>
		<td><b>Blog URL:</b></td>
		<td><?php bloginfo('url'); ?></td>
	</tr>
</table>
<p></p>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php echo PLUGIN_URI.'img/ok.gif'; ?>" alt=""></td>
		<td><b>Image Hyperlinking</b>:</td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"></td>
		<td><b>Link images to Blog URL?</b></td>
		<td>
			<select name="fhr_link_setting">
			<option
			<?php if(get_option('fhr_link_setting') == "yes") { echo "selected"; } ?>
				value="yes">Yes</option>
			<option
			<?php if(get_option('fhr_link_setting') == "no") { echo "selected"; } ?>
				value="no">No</option>
			</select>
		</td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"></td>
		<td>This setting turns on and off hyperlinking.</td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"></td>
		<td><b>Use local jQuery javascript file (included with plugin) or use the Google AJAX API?</b><td>
		<td><select name="fhr_link_type">
				<option <?php if(get_option('fhr_link_type') == "local") { echo "selected"; } ?> value="local">Local file</option>
				<option <?php if(get_option('fhr_link_type') == "google") { echo "selected"; } ?> value="google">Google API</option>
			</select>
		</td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"></td>
		<td>This determines if the javascript functions are called from a local <a href="http://jquery.com/">jQuery</a> javascript file (included with plugin) or if the functions are called remotely from the <a href="http://code.google.com/apis/ajaxlibs/">Google AJAX API</a> service. The Google API saves you some bandwidth, could possibly increase speed and load times, correctly sets cache headers, and stays up to date with the most recent bug fixes. Or you can use the locally hosted javascript file included in this plugin if you run into problems with the Google API. Both acheive the same result.</td>
	</tr>
</table>
	<tr>
	<hr />
	<h2>Flash settings</h2>
	<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php echo PLUGIN_URI.'img/ok.gif'; ?>"></td>
		<td><b>Flash version</b>:</td>
		<td><input type="text" name="fhr_flash1" size="1" border="0" value="<?php echo get_option('fhr_flash1'); ?>">.<input type="text" name="fhr_flash2" size="1" border="0" value="<?php echo get_option('fhr_flash2'); ?>">.<input type="text" name="fhr_flash3" size="1" border="0" value="<?php echo get_option('fhr_flash3'); ?>"></td></tr>
</table>
	</tr>
	<tr>Specify the minimum version of Flash you want your vieweres to have in order to load SWF headers via this plugin.</tr>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php echo PLUGIN_URI.'img/ok.gif'; ?>"></td>
		<td><b>Flash CSS styling</b>:</td>
		<td><input type="text" name="fhr_flash_css" size="80" border="0" value="<?php echo get_option('fhr_flash_css'); ?>"></td>
	</tr>
</table>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php echo PLUGIN_URI.'img/ok.gif'; ?>"</td>
		<td><b>Transparency mode:</b></td>
		<td><select name="fhr_transparency">
			<option
			<?php if(get_option('fhr_transparency') == "0") { echo "selected"; } ?>
				value="0">Off</option>
			<option
			<?php if(get_option('fhr_transparency') == "1") { echo "selected"; } ?>
				value="1">On</option>
		</select></td>
	</tr>
</table>
	<tr>Transparency mode is on by default.  Change it to "Off" if you do not want the background of your Flash animation to be transparent.</tr>
<table border="0" cellspacing="2" cellpadding="0">
	<tr>
		<td width="20"><img src="<?php echo PLUGIN_URI.'img/ok.gif'; ?>"</td>
		<td><b>Publishing mode:</b></td>
		<td><select name="fhr_pubmode">
			<option
			<?php if(get_option('fhr_pubmode') == "0") { echo "selected"; } ?>
				value="0">Static</option>
			<option
			<?php if(get_option('fhr_pubmode') == "1") { echo "selected"; } ?>
				value="1">Dynamic</option>
		</select></td>
	</tr>
</table>
	<tr>See <a href="http://code.google.com/p/swfobject/wiki/documentation">here</a> for the difference in SWFObject's static and dynamic publishing modes.  The default mode is static.</tr>
</table>
<p><input type="submit" name="submitButtonName" value="Update" border="0"></p>
</form>

<h2>Images</h2>
<ul>
<?php
$image_array = (get_files(IMAGE_PATH));
if($image_array == 0){
	echo "<font color=\"red\">Cannot find any pictures. Please resolve any image path errors above.</font>";
} else {
	$pics = count(get_files(IMAGE_PATH));
	if($pics == 0) {
		echo "<font color=\"red\">Could not find any pictures.</font>";
	}
	foreach($image_array as $entry){
		echo '<li><a href="javascript:void(0)" onClick="open_win(\''.IMAGE_URI.$entry.'\', \'header\', \'width=500,height=250,status=no,toolbar=no,menubar=no,scrollbars=yes,resizable=yes\')">'.$entry . '</a> <a href="'. $_SERVER["REQUEST_URI"].'&to_del='.$entry.'" title="delete file" >[X]</a></li>';

	}
}
?>
</ul>
<h2>About this plug-in</h2>
For more information and support, go to <a href="http://jaal.pranshuarya.com">Jaal</a>.<br>
</div>
<?php
}

/* Add actions */
add_action('admin_menu', 'rotator_admin_menu');
add_action('admin_head', 'fhr_add_js');

/* Check for correct initialization, if not found, don't add css */
if(is_dir(IMAGE_PATH) && count(get_files(IMAGE_PATH)) > 0) {
	add_action('wp_head', 'fhr_add_css');
}
?>